/*============================================================*

 *============================================================*/

#include "p4.h"

#define ZERO 0
#define HIGH 1
#define LOW  2

#define MAX      250000
/*#define MIN      200 */
#define MIN      10
#define LOOP     100
/*#define INNER    100*/
#define INNER    10
#define RECEIVED 1
#define NOT_RECD 0
/*#define SMALL    100*/
#define SMALL    10

int     step, size, data, max;
int     DATA[10];

/*============================================================*
  Procedure Name : 
  Function       : 
  Input          : 
  Output         : 
 *============================================================*/
/*============================================================*
  Procedure Name : 
  Function       : 
  Input          : 
  Output         : 
 *============================================================*/


/*============================================================*
  Procedure Name : slave()
  Function       : 
  Input          : none
  Output         : none
 *============================================================*/
slave() {

  int    i, myid;
  int    *incoming;
  int    size, from, type, nproc;
  int    check, status, master;

  myid = p4_get_my_id();
  nproc = p4_num_total_ids() - 1; master = 0;

  /* The start sign from the master. */
  type = 100;
  size = sizeof(int);
  from = 0;
  incoming = NULL;
  p4_recv(&type, &from, &incoming, &size);
  status = incoming[0];
  p4_msg_free(incoming);

  if ( status == HIGH ) {
    max = MIN;
  }
  else {
    max = MAX;
  }
   
  data = SMALL;


  printf("===========\n");
  p4_dprintf("My id : %d \n", myid);
  p4_dprintf("Status : %d\n", status);
  printf("===========\n");

  fflush(stdout);
  size = sizeof(int) * 10;

  for ( step = 0 ; step < LOOP ; step++ ) {
    execute();
  }

  type = 200;
  p4_send(type, master, &myid, size);
}

/*============================================================*
  Procedure Name : execute()
  Function       : 
  Input          : 
  Output         : 
 *============================================================*/
execute() {
  int     i, received;

  for ( i = 0 ; i < INNER ; i++ ) {
    unit_time();
    received = asyn_recv();
    if ( received ) {
      break;
    }
  }
  if ( !received ) {
    for ( i = 0 ; i < data ; i++ ) {
/*    broadcast();*/
      p4_broadcast(step, DATA, size);
    }
  }
}


/*============================================================*
  Procedure Name : unit_time()
  Function       : 
  Input          : 
  Output         : 
 *============================================================*/
unit_time() {
  int    i, j;

  for ( i = 0 ; i < max ; i++ ) {
    j = 1;
  }
}

/*============================================================*
  Procedure Name : broadcast()
  Function       : 
  Input          : 
  Output         : 
 *============================================================*/
broadcast() {

  p4_broadcast(step, DATA, size);
}

/*============================================================*
  Procedure Name : 
  Function       : 
  Input          : 
  Output         : 
 *============================================================*/
int asyn_recv() {
  int     i, from, check;
  int     *incoming;

  from = -1;
  check = p4_messages_available(&step, &from);

  if ( check ) {
    for ( i = 0 ; i < data ; i++ ) {
      incoming = NULL;
      p4_recv(&step, &from, &incoming, &size);
      p4_msg_free(incoming);
    }
  }
  return check;
}

/*============================================================*
  Procedure Name : 
  Function       : 
 *============================================================*/
/*
main (argc, argv)
     int     argc;
     char    **argv;
{
  p4_initenv(&argc, argv);
  p4_create_procgroup();
  slave();
  p4_wait_for_end();
  exit(0);
}
*/
